<template lang="pug">
button.btn.btn-ghost.text-gray-500.space-x-1(@click.stop.default="toggle")
  icon.w-4.h-4(name="clarity:search-line")
  span.hidden.text-xs.font-semibold.normal-case(class="sm:inline") {{ $t('search') }}
  p.hidden.text-xs.font-semibold.normal-case.border.border-neutral.rounded-sm.p-px.px-1(
    class="sm:block"
  ) /
  client-only
    teleport(to="#modals")
      app-search-modal(v-if="show", @close="toggle")
</template>

<script setup lang="ts">
import { onBeforeMount, onBeforeUnmount, ref, watch, watchEffect } from 'vue'

const show = ref(false)

const toggle = () => (show.value = !show.value)

watch(show, (value, _) => {
  value
    ? document.body.classList.add('overflow-hidden')
    : document.body.classList.remove('overflow-hidden')
})

// watchEffect(() => console.log(show))
const onDocumentKeydown = (e: KeyboardEvent) => {
  if (
    (e.key === '/' || e.key === 'Escape') &&
    e.target instanceof HTMLInputElement === false &&
    e.target instanceof HTMLSelectElement === false &&
    e.target instanceof HTMLTextAreaElement === false
  ) {
    e.preventDefault()
    if (e.key === 'Escape' && !show.value) return
    toggle()
  }
}

onBeforeMount(() => {
  window.document.addEventListener('keydown', onDocumentKeydown)
})
onBeforeUnmount(() =>
  window.document.removeEventListener('keydown', onDocumentKeydown)
)
</script>
